// Nome: Classi.ch
// Include per la libreria Classi.Lib e la SimLib
// permette la creazione di nuove classi

#define _CLASSI_

#xcommand DEFAULT <uVar1> := <uVal1> ;
               [, <uVarN> := <uValN> ] => ;
                  <uVar1> := If( <uVar1> == nil, <uVal1>, <uVar1> ) ;;
                [ <uVarN> := If( <uVarN> == nil, <uValN>, <uVarN> ); ]

#xcommand EXPORT:    => _sclsscope(0)
#xcommand PUBLIC:    => _sclsscope(0)
#xcommand PROTECTED: => _sclsscope(4096)
#xcommand PRIVATE:   => _sclsscope(8192)
#xcommand SPECIAL:   => _sclsscope(1)
// nascosta 12288


#define CLS_GETHANDLE -1

#define CLS_SCOPE      1
#define CLS_ALLVIRTUAL 2

#xcommand SET OCLIP COMP   => cls_set(CLS_ALLVIRTUAL,.T.);;
                              cls_set(CLS_SCOPE,.F.)
#xtranslate :: => self:

#xtranslate CONSTRUCTOR <classname>::<*altro*> => ;
  CONSTRUCTOR <altro>
#xcommand CONSTRUCTOR <ctor>([<Params,...>]) NO PARENT => ;
  static function <ctor>( Self [, <Params>] )

#xcommand CONSTRUCTOR <ctor>([<list,...>]) => ;
  constructor <ctor>(<list>) parent new(<list>)

#xcommand CONSTRUCTOR <ctor>([<list,...>]) PARENT <method> => ;
  constructor <ctor>(<list>) parent <method>(<list>)

//#xcommand CONSTRUCTOR <ctor>([<list,...>]) PARENT <method>([<pars,...>]) => ;
//  static function <ctor>( Self [, <list>] ) ;;
//  local __Dummy:=::parent():<method>(<pars>)

#xcommand CONSTRUCTOR <ctor>([<list,...>]) PARENT <method>([<pars,...>]) => ;
  static function <ctor>( Self [, <list>] ) ;;
  local __Dummy:=::parent():<method>(<pars>)

//----------------------------------------------------------------------

#xcommand        CLASS <name> [FROM <parent>] => CLASS <name> [XFROM <parent>(CLS_GETHANDLE)]
#xcommand CREATE CLASS <name> [FROM <parent>] => CLASS <name> [XFROM <parent>(CLS_GETHANDLE)]

#xcommand CLASS <name> [ XFROM <parent> ] => ;
  FUNCTION <name>(_p1);;
  STATIC hClass := 0;;
    if hClass == 0;;
      __DefineClass(<"name">,<{parent}>)

#xcommand VAR <var1> [,<varN>] [<ro: READONLY> ] [<new: NEW>] => ;
      __AddVar({<"var1"> [,<"varN"> ]},<.ro.>,<.new.>)

//---------------- per compatibilita' con oClip -----------------------
// deve essere prima dei METHOD seguenti, non spostarlo di posizione!!!
#xcommand METHOD <methodName> [,<*methodN*>] =>;
      __AddMethod(<"methodName">,<"methodName">,.f.) [; METHOD <methodN>]

#xcommand METHOD <methodName> = <methodUDF> [,<*methodN*>] => ;
      __AddMethod(<"methodName">, <"methodUDF">,.f.) [; METHOD <methodN>]

// per velocizzare: chiamarlo come blocco {|p1,p2,p3,p4..| <methodUDF>(p1,p2,p3..)}
//---------------------------------------------------------------------

// #xcommand VIRTUAL METHOD <*rest*>  => METHOD <rest> VIRTUAL


#xcommand METHOD <methodName>( [<uParms,...>] ) [<new: NEW>] [<vir: VIRTUAL>]  => ;
      __AddMethod(<"methodName">,{|_pqs [,<uParms>] | <methodName>(_pqs [,<uParms>])},<.vir.>,<.new.>)

#xcommand METHOD <methodName> = <methodUDF>( [<uParms,...>] ) [<new: NEW>] [<vir: VIRTUAL>]  => ;
      __AddMethod(<"methodName">,{|_pqs [,<uParms>] | <methodUDF>(_pqs [,<uParms>])},<.vir.>,<.new.>)

#xcommand METHOD <methodName>( [<uParms,...>] ) [<new: NEW>] [<vir: VIRTUAL>] INLINE <*proc*>   => ;
      __AddMethod(<"methodName">,{|self [,<uParms>] | <proc> },<.vir.>,<.new.>)

#xcommand ENDCLASS => ;
      hClass := __MakeClass();;
    end;;
  if _p1!=NIL; return hClass ;end ;;
  return __ClassIns(hClass)

//----------------------------------------------------------------------


#xtranslate METHOD <cClassName>::<cMethodName>( [<uParms,...>] ) =>   ;
  static function <cMethodName>( Self [, <uParms>] )

#xtranslate METHOD <cMethodName>( [<uParms,...>] ) CLASS <cClassName> =>  ;
  static function <cMethodName>( Self [, <uParms>] )

//------------------ per compatibilita' con oClip -----------------------
#xcommand METHOD PROCEDURE <cMethodName>( [<uParms,...>] )  => ;
  procedure <cMethodName>( Self [, <uParms>] )
#xcommand METHOD FUNCTION <cMethodName>( [<uParms,...>] )  => ;
  function <cMethodName>( Self [, <uParms>] )
//------------------------------------------------------------------------

#xcommand ENDMETHOD =>  return Self

#xtranslate :super => :parent

#xtranslate :parent([<class>]):<method> =>:__PARENT(<class>(CLS_GETHANDLE)):<method>

#xtranslate parent:<method>:<*Anything*> => ;
  #error Chaining not allowed after overridden method call.

//--------------------- compatibilita' oclip ---------------------------------
#xtranslate OBJECT [<Obj>] OF <Class> => [<Obj>:=]<Class>():New()
#xtranslate OBJECT <Obj> OF <Class> INIT => <Obj>:=<Class>():New(); <Obj>:Init()
#xtranslate OBJECT <Obj> OF <Class> INIT <*Tail*> => <Obj>:=<Class>():New(); <Obj>:Init(); (<Tail>)
//----------------------------------------------------------------------------
