// Nome  : CtrlNew.ch
// Autore: Nicola Simeoni
// Descrizione:

// Nuove definizioni per i comandi @..SAY..GET ecc., che utilizzano
// le nuove classi messe a disposizione dalla libreria Classi, integrata
// all'interno della SimLib.
// Se non si vuole usare questa gestione (che necessita di maggiori risorse
// in termini di memoria occupata) , prima di #includere la SimLib.ch,
// definire la macro SIM_OLDVERSION: verra' cosi' utilizzato CtrlOld.ch


// ---------------------- Comandi @...  -----------------------------
#translate UPDATED() =>    sUpdated()
#translate ReadKill(<lexit>) => sReadKill(<lexit>)

#xtranslate bSETGET(<uVar>) => ;
            { | _xv | If( _xv==NIL, <uVar>, <uVar> := _xv ) }

#command @ <row>, <col> STATIC <expr>                  ;
                        [PICTURE <pic>]                ;
                        [COLOR <cColor>]               ;
     =>AAdd(GetList,cStatic():New(<row>, <col>,<expr>,<pic>,<cColor>):display())

#command @ <row>, <col> GET <var>                      ;
                        [PICTURE <pic>]                ;
                        [VALID <valid>]                ;
                        [WHEN <when>]                  ;
                        [MESSAGE <messaggio>]          ;
                        [<ca:CALC>]                    ;
                        [SEND <msgSend>]               ;
                                                       ;
      => SetPos( <row>, <col> )                        ;
       ; AAdd( GetList,cGet():NewG(_GET_(<var>, <(var)>, <pic>,<{valid}>,;
               <{when}>),<.ca.>,<messaggio> ):display()  )      ;
      [; ATail(GetList):<msgSend>]

#command @ <row>, <col> PUSHBUTTON [CAPTION] <cCaption>  ;
                       [ACTION <bAction>]      ;
                       [SHADOW <cShColor>]     ;
                       [COLOR  <cColor>]       ;
                       [VALID <bvalid> ]       ;
                       [WHEND  <bwhen> ]       ;
                       [MESSAGE <cMsg> ]       ;
                       [<nocf :NOCLICKFOCUS>]  ;
                       [<def  :DEFAULT>]       ;
                       [SEND <msgSend>]        ;
         =>                                    ;
         AAdd( GetList, cButton():New(<row>,<col>,<cCaption>,<{bAction}>,;
         <cColor>,<cShColor>):display()  )     ;
      [; ATail(GetList):Message  :=<cMsg>]     ;
      [; ATail(GetList):ClickSetFocus:=!<.nocf.>]   ;
      [; ATail(GetList):Default:=<.def.>]       ;
      [; ATail(GetList):PostBlock:=<{bvalid}>]  ;
      [; ATail(GetList):PreBlock :=<{bwhen}>]   ;
      [; ATail(GetList):<msgSend>]



#command @ <row>, <col> GET <lvar> PUSHBUTTON CAPTION <cCaption>   ;
                       [STATE  <bAction>]      ;
                       [COLOR  <cColor>]       ;
                       [SHADOW <cShColor>]     ;
                       [VALID  <bvalid> ]      ;
                       [WHEND  <bwhen>  ]      ;
                       [MESSAGE <cMsg>]        ;
                       [SEND <msgSend>]        ;
         =>                                    ;
         AAdd( GetList, cButton():New(<row>,<col>,<cCaption>,<{bAction}>,;
         <cColor>,<cShColor>):display()  )     ;
      [; ATail(GetList):Message  :=<cMsg>]     ;
      [; ATail(GetList):PostBlock:=<{bvalid}>] ;
      [; ATail(GetList):PreBlock :=<{bwhen}>]  ;
      [; ATail(GetList):<msgSend>]

#command @ <row>, <col> GET <lVar> CHECKBOX CAPTION <cCaption>    ;
                       [STATE  <bAction>]      ;
                       [VALID  <bvalid> ]      ;
                       [WHEND  <bwhen>  ]      ;
                       [COLOR  <cColor>]       ;
                       [MESSAGE <cMsg>]        ;
                       [SEND <msgSend>]        ;
         =>                                    ;
         AAdd( GetList, cCheck():New(<row>,<col>,<cCaption>,bSetGet(<lVar>),;
         <(lVar)>,<cColor>):display()  )       ;
      [; ATail(GetList):Message  :=<cMsg>]     ;
      [; ATail(GetList):PostBlock:=<{bvalid}>]   ;
      [; ATail(GetList):PreBlock :=<{bwhen}>]    ;
      [; ATail(GetList):Action   :=<{bAction}>] ;
      [; ATail(GetList):<msgSend>]


#command @ <Row>,<Col> SIZE <nHeight>,<nWidth> <*rest*> => ;
         @ <Row>,<Col>,<Row>+<nHeight>-1, <Col>+<nWidth>-1 <rest>

#command @ <nTop>,<nLeft>,<nBottom>,<nRight> GET <nVar> RADIOGROUP <aGroup> ;
                       [CAPTION <cCaption>]    ;
                       [STATE  <bAction>]      ;
                       [VALID  <bvalid> ]      ;
                       [WHEND  <bwhen>  ]      ;
                       [COLOR  <cColor> ]      ;
                       [MESSAGE <cMsg>  ]      ;
                       [TO     <oGroup> ]      ;
                       [SEND <msgSend>]        ;
         =>                                    ;
         AAdd( GetList, cRadioGroup():New(<nTop>,<nLeft>,<nBottom>,<nRight>,<cCaption>,[bSetGet(<nVar>)],;
         <(nVar)>,<cColor>,<aGroup>):display()  )       ;
      [; ATail(GetList):Message  :=<cMsg>]     ;
      [; ATail(GetList):PostBlock:=<{bvalid}>]   ;
      [; ATail(GetList):PreBlock :=<{bwhen}>]    ;
      [; ATail(GetList):Action   :=<{bAction}>]  ;
      [; <oGroup> := ATail(GetList)]             ;
      [; ATail(GetList):<msgSend>]

#command @ <Row>,<Col> GET [<lVar>] RADIO CAPTION <cCaption> GROUP <oGroup>  ;
                       [STATE  <bAction>]      ;
                       [VALID  <bvalid> ]      ;
                       [WHEND  <bwhen>  ]      ;
                       [COLOR  <cColor> ]      ;
                       [MESSAGE <cMsg>  ]      ;
                       [SEND <msgSend>]        ;
         =>                                    ;
         <oGroup>:AddItem(cRadio():New(<Row>,<Col>,<cCaption>,[bSetGet(<lVar>)],;
         <(lVar)>,<cColor>):display()  )       ;
      [; ATail(<oGroup>:aRadio):Message  :=<cMsg>]     ;
      [; ATail(<oGroup>:aRadio):PostBlock:=<{bvalid}>]   ;
      [; ATail(<oGroup>:aRadio):PreBlock :=<{bwhen}>]    ;
      [; ATail(<oGroup>:aRadio):Action   :=<{bAction}>] ;
      [; ATail(GetList):<msgSend>]

#command @ <nTop>,<nLeft>,<nBottom>,<nRight> GET <nVar> LISTBOX <aItems> ;
                       [CAPTION <cCaption>]    ;
                       [STATE  <bAction>]      ;
                       [VALID  <bvalid> ]      ;
                       [WHEND  <bwhen>  ]      ;
                       [COLOR  <cColor> ]      ;
                       [MESSAGE <cMsg>  ]      ;
                       [<asel  :AUTOSELECT>]   ;
                       [SEND <msgSend>]        ;
         =>                                    ;
         AAdd( GetList, cListBox():New(<nTop>,<nLeft>,<nBottom>,<nRight>,<cCaption>,[bSetGet(<nVar>)],;
         <(nVar)>,<cColor>,<aItems>):display()  )       ;
      [; ATail(GetList):Message  :=<cMsg>]     ;
      [; ATail(GetList):PostBlock:=<{bvalid}>]   ;
      [; ATail(GetList):PreBlock :=<{bwhen}>]    ;
      [; ATail(GetList):Action   :=<{bAction}>]  ;
      [; ATail(GetList):AutoSelect :=<.asel.>]  ;
      [; ATail(GetList):<msgSend>]

#command @ <row>, <col> PROMPT <prompt> [MESSAGE <msg>]                 ;
      => SimPrompt( <row>, <col>, <prompt> , <msg> )

#command MENU TO <v>                                                    ;
      => <v> := SimMenuTo( <v>, #<v> )

// ----------------------    Menu       -----------------------------

#xcommand MENU <oMenu> [AT <nTop>,<nLeft>] [TO <nBottom>,<nRight>] ;
      [ <popup: POPUP,VERTICAL> ]     ;
      [ <noborder: NOBORDER> ]  =>    ;
      <oMenu> := cMenu():New( if(<.popup.>,OVERTICAL,OHORIZONTAL) [,<nTop>,<nLeft>][,<nBottom>,<nRight>]) ;
      ; _mlastMnu(<oMenu>)            ;
      [;_mlastMnu():border := if(<.noborder.>,NIL,1)]
#xcommand MENUITEM <cCaption>         ;
             [ MESSAGE <cMsg> ]       ;
             [ ACTION <uAction> ]     ;
             [ ID <nId>]              ;
       => _mLastMnu():AddItem( { <cCaption>,<{uAction}>, <cMsg>,<nId> })

#xcommand SUBMENU <cCaption>          ;
             [ MESSAGE <cMsg> ]       ;
             [ ID <nId>]              ;
       => _mLastMnu(cMenu():New(OVERTICAL,,,,,,_mLastMnu())) ;
       ;  _mLastMnu():oOwner:AddItem({ <cCaption>,_mLastMnu(),<cMsg>,<nId> } );

#xcommand ENDMENU    => ENDSUBMENU
#xcommand ENDSUBMENU =>_mLastMnu(_mLastMnu():oOwner)

//----------------------------  Maschere    ---------------------------
#command @ <nome> SAY <xpr>                            ;
                  [PICTURE <pic>]                      ;
                  [COLOR <col>]                        ;
      => MSKc_leggi('`'+<(nome)>) ;
      ; AAdd( GetList,cStatic():New(Row(),Col(),<xpr>,[<pic>],[<col>]):display()) ;
      ; ATail(GetList):name:='`'+<(nome)> ;
      ; Mskc_Sposta()


#command @              [SAY <xpr>]                    ;
                        GET <var>                      ;
                        [PICTURE <pic>]                ;
                        [VALID <valid>]                ;
                        [WHEN <when>]                  ;
                        [MESSAGE <messaggio>]          ;
                        [<ca:CALC>]                    ;
                        [COLOR <col>]                  ;
                        [SEND <msgSend>]               ;
                                                       ;
      => Mskc_Leggi(<(var)>,<xpr>)                     ;
       ; AAdd( GetList,cGet():NewG(_GET_(<var>, <(var)>, <pic>,<{valid}>,;
               <{when}>),<.ca.>,<messaggio>,[<xpr>]):display()  )      ;
      [; ATail(GetList):<msgSend>]  ;
      ; Mskc_Sposta()


#command @ <name> PUSHBUTTON [CAPTION] <cCaption> <*rest*>  ;
      => Mskc_Leggi(<(name)>)                               ;
       ; @ Row(),Col() PUSHBUTTON <cCaption> <rest>         ;
       ; ATail(GetList):name:=<(name)>                      ;
       ; Mskc_Sposta()

#command @ GET <lVar> CHECKBOX CAPTION <cCaption> [<*rest*>] ;
      => Mskc_Leggi(<(lVar)>)                              ;
       ; @ Row(),Col() GET <lVar> CHECKBOX CAPTION <cCaption> <rest> ;
       ; Mskc_Sposta()


#command MREAD     ;
      => READ      ;
       ; msk_read()

#command @ <nome> PROMPT <prompt> [MESSAGE <msg>]  ;
      => msk_prompt(<prompt> , <msg> , <(nome)> )

#command MMENU TO <v>  ;
      => MENU TO <v>   ;
      ;  msk_read()
//-----------------------------  read  ------------------------------
#xcommand MOUSEREAD => READ
#xcommand READ [MENU <oMenu>]    ;
               [MSG AT <Row> , <Left> , <Right>] ;
               [MSG COLOR <color>] ;
      => cRead():New(<Row>,<Left>,<Right>):ReadModal(GetList,<oMenu>)   ;
      ;  GetList:={}


