// Nome Prog.  : SIMLIB.CH
// Autore      : Nicola Simeoni
// Descrizione : File da #incudere nei prg che fanno uso delle funzioni
//               della libreria SimLib

// N.B. questo file sostituisce i precedenti Sim5.ch e Sim52.ch e va bene
// sia per Clipper 5.01 che per 5.2

// Se si desidera utilizzare la vecchia gestione dei GET, definire
// la macro SIM_OLDVERSION
// Se si desidera usare la gestione dei GET standard del Clipper, definire
// la macro SIM_NOCONTROL

*  Definizioni delle funzioni che restituiscono lo stato dei SET
*
#ifndef _SIMLIB_
#translate S_ALTERNAT() =>     SET(_SET_ALTERNATE)
#translate S_BELL() =>         SET(_SET_BELL)
#translate S_CENTURY() =>      __SetCentury()
#translate S_CONFIRM() =>      SET(_SET_CONFIRM)
#translate S_CONSOLE() =>      SET(_SET_CONSOLE)
#translate S_CURSOR() =>       if(SetCursor()=0,.F.,.T.)
#translate S_DELETED() =>      SET(_SET_DELETED)
#translate S_DELIMITE() =>     SET(_SET_DELIMITERS)
#translate S_ESCAPE() =>       SET(_SET_ESCAPE)
#translate S_EXACT() =>        SET(_SET_EXACT)
#translate S_EXCLUSIV() =>     SET(_SET_EXCLUSIVE)
#translate S_FIXED() =>        SET(_SET_FIXED)
#translate S_INTENSIT() =>     SET(_SET_INTENSITY)
#translate S_PRINT() =>        SET(_SET_PRINTER)
#translate S_SCOREBOA() =>     SET(_SET_SCOREBOARD)
#translate S_SOFTSEEK() =>     SET(_SET_SOFTSEEK)
#translate S_UNIQUE() =>       SET(_SET_UNIQUE)
#translate S_WRAP() =>         SET(_SET_WRAP)
#translate S_DEVICE(<c>) =>    SET(_SET_DEVICE,<c>)
#translate S_DEVICE() =>       SET(_SET_DEVICE)
#translate S_DATE(<C>) =>      SET(_SET_DATEFORMAT,<C>)
#translate S_DATE() =>         SET(_SET_DATEFORMAT)
#translate S_DECIMALS() =>     SET(_SET_DECIMALS)
#translate S_DECIMALS() =>     SET(_SET_DECIMALS)
#translate S_PATH() =>         SET(_SET_PATH)
#translate S_KEY(<x>) =>       SETKEY(<x>)

#xcommand REPEAT => while .t.
#xcommand LOOPIF <lExpr> => if <lExpr>; loop; end
#xcommand EXITIF <lExpr> => if <lExpr>; exit; end
#xcommand UNTIL <lExpr>  => if <lExpr>; exit; end; end


// ----------------   Per funzione SimSet() ----------------------

#define SSET_ESPLTIME          1
#define SSET_MOUSEEXIT         3
#define SSET_ENTER_CHANGE      4
#define SSET_VALIDBEEP         6
#define SSET_MENUGOTOP         7
#define SSET_LANGUAGE          8
 #define SSET_ENGLISH             0
 #define SSET_ITALIAN             1


// ----------------  Codici Mouse riturnati da m_inkey() ----------------
#define K_MOUSE          1000
#define K_LEFTCLICK      1001
#define K_RIGHTCLICK     1002
#define K_CENTERCLICK    1004
#define K_LEFTDBLCLICK   1011
#define K_RIGHTDBLCLICK  1022
#define K_CENTERDBLCLICK 1044

// ----------------   Per gestione CD ----------------------
#define CD_FIRSTTRACK   1
#define CD_LASTTRACK    2
#define CD_VERSION      3
#define CD_DRIVE        4
#define CD_ISCHANGED    5
#define CD_DISKPRESENT  6
// Per CD_STATUS()
#define CD_ISPAUSED     1
#define CD_TRACK        2
#define CD_MINUTE       3
#define CD_SECOND       4

//------------------- Orientazione Scroll Bar e Menu

#define OVERTICAL     1
#define OHORIZONTAL   2

#endif  // _SIMLIB_

#ifndef SIM_NOCONTROL
  #ifdef SIM_OLDVERSION
    #include "CtrlOld.ch"
  #else
    #include "CtrlNew.ch"
  #endif
#endif

