*--------------------------------------------------------------
* Name :  Graphic.prg
* date :  22/01/96
* by   :  Nicola Simeoni
*
* Compile with Clipper 5.xx

#include "colors.ch"
local video,colore1,colore2,colore3,bianco
local xm,ym,MaxColor,h,l
local SaveSc
local sr:=0,sg:=0,sb:=0,r,g,b

Init_Sim()
scroll()
@ 3,1 say "Select graphic mode"
video:=Choose_video()
if video==0 .or. setvideo(video)<0
  return
endif
xm=GetMaxX()
ym=GetMaxY()
MaxColor:=GetMaxColor()
if MaxColor>256
  colore1:=RGB_RED
  colore2:=RGB_GREEN
  colore3:=RGB_LIGHTBLUE
  bianco:=RGB_WHITE
else
  colore1:=VGA_RED
  colore2:=VGA_GREEN
  colore3:=VGA_LIGHTBLUE
  bianco:=VGA_WHITE
endif

DrawBar(0,0,xm/3,ym,colore1)
DrawBar(xm/3,0,2*xm/3,ym,colore2)
DrawBar(2*xm/3,0,xm,ym,colore3)
DrawBox(xm/4,ym/4,3*xm/4,3*ym/4,bianco)
Continua(bianco)


for i=1 to 10
  circle(Xm/2,ym/2,(ym/20)*i,RandColor(MaxColor))
next i
fillcircle(Xm/2,ym/2,int(ym/20),colore2)
Continua(bianco)



for i=1 to 3
  cornice((i-1)*Xm/6,(i-1)*ym/6,xm-(i-1)*Xm/6,ym-(i-1)*ym/6,colore3,i)
next i
Continua(bianco)

for i=1 to 2
  frame3d((i-1)*Xm/8,(i-1)*ym/8,xm-(i-1)*Xm/8,ym-(i-1)*ym/8,i)
next i
for i=3 to 4
  frame((i-1)*Xm/8,(i-1)*ym/8,xm-(i-1)*Xm/8,ym-(i-1)*ym/8,i-2)
next i
Continua(bianco)


if !file("litt.chr")
  txtmode()
  ? "LITT.CHR not found...."
  return
endif
Font_Load("Litt.chr")
Font_Just(1,1,0)
Font_Size(4)
Font_Color(colore1)
Font_Write(10,50,"Size 4")
Font_Size(8)
Font_Color(colore2)
Font_Write(10,100,"Size 8")
Font_Size(16)
Font_Color(colore3)
Font_Write(10,180,"Size 16")
Continua(bianco)


putpixel(1,1,colore1)
colore:=getpixel(1,1)
putpixel(3,3,colore)
for i=1 to 20
  line(0,ym,xm,(ym/20)*i,RandColor(MaxColor))
next i
Continua(bianco)

//************* Icons (32x32)

if MaxColor<=256
  line(50,50,81,81,colore1)
  line(81,50,50,81,colore1)
  IconGet(50,50,"nico.pip",255)
  IconPut(100,100,"nico.pip")
  vIcona:=IconLoad("sim.icn")
  IconPut(150,150,vIcona)
  Continua(bianco)
endif

//************* Pcx e Gif

if MaxColor==255
  Pcx_Info("SimLib.pcx")
  h:=img_height()
  l:=img_width()
  Pcx_Read("SimLib.pcx",(xm-l)/2,(ym-h)/2)
  Continua(bianco)
elseif MaxColor==15
  Pcx_Info("SimLib.pcx")
  h:=img_height()
  l:=img_width()
  Pcx_Read("SimLib16.pcx",40,40)
  SaveSc:=gBoxSave(30,30,40+l,40+h)
  Continua(bianco)
  for i=1 to 10
    gBoxRestore(i*10,i*10,i*10+l+10,i*10+h+10,SaveSc)
    attendi(2)
  next i
  Continua(bianco)
endif
if MaxColor>=255
  Gif_Info("Sim2.gif")
  h:=img_height()
  l:=img_width()
  a=Gif_Read("Sim2.gif",40,40)
  SaveSc:=gBoxSave(30,30,40+l,40+h)
  Continua(bianco)
  for i=1 to 10
    gBoxRestore(i*10,i*10,i*10+l+10,i*10+h+10,SaveSc)
    attendi(2)
  next i
  Continua(bianco)
endif

//************* RGB_GET   e   RGB_SET

if MaxColor<=255
  DrawBar(100,100,200,200,1)
  RGB_GET(1,@sr,@sg,@sb)
  for i=1 to 6
    for j=0 to 63
      r := if(i==1 .or. i==4 .or. i==5,j,63-j)
      g := if(i==2 .or. i==4 .or. i==6,j,63-j)
      b := if(i==3 .or. i==5 .or. i==6,j,63-j)
      rgb_set(1,r,g,b)
    next j
    if inkey()!=0 ; exit ;endif
  next i
  rgb_set(1,sr,sg,sb)
  Continua(bianco)
endif

//************* RGB_COLOR

r:=0;g:=0;b:=0
if MaxColor>255
  inc:=(255*3)/ym
  for i=0 to ym
    DrawBar(0,i,xm,i,RGB_COLOR(r,g,b))
    if(i<ym/3,r+=inc,)
    if(i<ym/3*2 .and. i>ym/3,g+=inc,)
    if(i>ym/3*2,b+=inc,)
  next i
  Continua(bianco)
endif

txtmode()
return


//---------------------------------------------------------------------

static function Continua(colore)
  if GetMaxColor()<=256
    GWrite(1,1,"Press a key to continue",colore)
  endif
  for i=1 to 8
    if inkey(1)!=0
      clrscr(0)
      return nil
    endif
  next i
  clrscr(0)
  return nil

//---------------------------------------------------------------------

static function RandColor(maxcol)
  if maxcol<=256
    return randomize(maxcol)
  endif
  return RGB_Color(55+randomize(200),55+randomize(200),55+randomize(200))

//---------------------------------------------------------------------

static function Choose_video()
  local aVideo:={"320x200  16 col","640x200  16 col","640x350  16 col",;
        "640x480  16 col","320x200  256 col","640x400  256 col",;
        "640x480  256 col","800x600  16  col","800x600  256 col",;
        "1024x768 16  col","1024x768 256 col","640x480 32k col",;
        "640x480 64k col","640x480 16M col"}
  local aMode:={13,14,16,18,19,256,257,258,259,260,261,272,273,274}
  local oList,nVideo:=0
  local scolor:=setcolor()
  local schermo:=wind_make(5,5,18,27,2,"W+/G,GR+/B",,.t.)

  nVideo := aChoice(6,6,17,26,aVideo)
  wind_del(schermo)
  setcolor(scolor)
  if nVideo==0
    return 0
  endif
  return aMode[nVideo]

